[![logo](https://www.hongsnet.net/images/logo.gif)](https://www.hongsnet.net)

# OS Version

```bash
# cat /etc/redhat-release
CentOS Linux release 7.9.2009 (Core)
```

# Kernel Version

```bash
# uname -a
Linux 호스트네임 3.10.0-1160.el7.x86_64 #1 SMP Mon Oct 19 16:18:59 UTC 2020 x86_64 x86_64 x86_64 GNU/Linux
```

# tuned status

```bash
# systemctl status tuned
● tuned.service - Dynamic System Tuning Daemon
   Loaded: loaded (/usr/lib/systemd/system/tuned.service; enabled; vendor preset: enabled)
   Active: active (running) since Thu 2022-01-13 11:29:34 KST; 3 months 27 days ago
     Docs: man:tuned(8)
           man:tuned.conf(5)
           man:tuned-adm(8)
 Main PID: 1434 (tuned)
   CGroup: /system.slice/tuned.service
           └─1434 /usr/bin/python2 -Es /usr/sbin/tuned -l -P
```

# tuned profile status

```bash
# tuned-adm active
Current active profile: powersave
```

또한 다음과 같이 CPU Clock이 **powersave** 프로파일에 맞게 평시 낮게 조정되어 있다.

```bash
# grep -E '^model name|^cpu MHz' /proc/cpuinfo
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 1200.926
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 1200.542
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 1200.926
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 1200.926
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 1200.054
...중략
```

# tuned profile setting

최적의 성능을 발휘할 수 있도록 다음과 같이 `latency-performance` 프로파일로 변경한다.

```bash
# tuned-adm profile latency-performance
```

이제 CPU의 Clock이 `성능(performance)`을 기준으로 조정된다.

```bash
# grep -E '^model name|^cpu MHz' /proc/cpuinfo
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 2399.926
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 2399.926
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 2399.926
model name      : Intel(R) Xeon(R) Silver 4110 CPU @ 2.10GHz
cpu MHz         : 2399.926
...중략
```

그런데, **model name**의 2.10GHz Clock이 **2.399GHz**로 조정되어 있는데, 이는 다음과 같이 **performance governors**에 따른 결과 이다. 

```bash
# cpupower frequency-info
analyzing CPU 0:
  driver: intel_pstate
  CPUs which run at the same hardware frequency: 0
  CPUs which need to have their frequency coordinated by software: 0
  maximum transition latency:  Cannot determine or is not supported.
  hardware limits: 800 MHz - 3.00 GHz
  available cpufreq governors: performance powersave
  current policy: frequency should be within 800 MHz and 3.00 GHz.
                  The governor "performance" may decide which speed to use
                  within this range.
  current CPU frequency: 2.40 GHz (asserted by call to hardware)
  boost state support:
    Supported: yes
    Active: yes
```

